using System.Collections.Generic;

namespace SimpleSpreadsheet.Core.Expressions
{
    /// <summary>
    /// Represents a function in parsed expression
    /// </summary>
    public class FunctionExpression : BaseExpression
    {
        public FunctionExpression(string identifier, List<BaseExpression> expressions)
        {
            Name = identifier;
            Expressions = expressions;
        }

        public string Name { get; set; }
        public List<BaseExpression> Expressions { get; set; }

        public override void Accept(ExpressionVisitor visitor)
        {
            visitor.Visit(this);
        }
    }
}