namespace SimpleSpreadsheet.Core.Expressions
{
    /// <summary>
    /// Represents the value in expression
    /// </summary>
    public class ValueExpression : BaseExpression
    {
        public ValueExpression(string text, ValueExpressionType expressionType)
        {
            Text = text;
            ExpressionType = expressionType;
        }

        public string Text { get; set; }
        public ValueExpressionType ExpressionType { get; set; }

        public override void Accept(ExpressionVisitor visitor)
        {
            visitor.Visit(this);
        }
    }

    public enum ValueExpressionType
    {
        Integer,
        String,
        Float
    }
}