﻿using System.Windows;
using System.Windows.Controls;

namespace SimpleSpreadsheet.Controls
{
    /// <summary>
    /// Represents a cell control in a worksheet
    /// </summary>
    public class CellControl : Button
    {
        public static readonly DependencyProperty RowProperty;
        public static readonly DependencyProperty ColumnProperty;

        static CellControl()
        {
            RowProperty = DependencyProperty.Register("RowNumber", typeof (int), typeof (CellControl));
            ColumnProperty = DependencyProperty.Register("ColumnNumber", typeof (int), typeof (CellControl));
        }

        public int RowNumber
        {
            get { return (int) GetValue(RowProperty); }
            set { SetValue(RowProperty, value); }
        }

        public int ColumnNumber
        {
            get { return (int) GetValue(ColumnProperty); }
            set { SetValue(ColumnProperty, value); }
        }
    }
}